#include "BProgram.h"
#include "Interleaver.h"
#include "SayGoodEvening.h"
#include "SayGoodMorning.h"
#include <cstdio>

int main()
{
    try
    {
        BProgram bProgram;
        bProgram.runEngine();

        SayGoodMorning sayGoodMorning;
        SayGoodEvening sayGoodEvening;
        Interleaver interleaver;

        bProgram.addThread( sayGoodMorning );
        bProgram.addThread( sayGoodEvening );
        bProgram.addThread( interleaver );

        bProgram.runProgram();
        sleep( 100 );
    }
    catch ( const Error &e )
    {
        printf( "Main Thread: Error caught. Code: %u. Errno: %i\n", e.code(), e.errno() );
        fflush( 0 );
    }

	return 0;
}

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
